package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdAccperiodyearExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdAccperiodyearExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkAcchalfyearIsNull() {
            addCriterion("PK_ACCHALFYEAR is null");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearIsNotNull() {
            addCriterion("PK_ACCHALFYEAR is not null");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearEqualTo(String value) {
            addCriterion("PK_ACCHALFYEAR =", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearNotEqualTo(String value) {
            addCriterion("PK_ACCHALFYEAR <>", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearGreaterThan(String value) {
            addCriterion("PK_ACCHALFYEAR >", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCHALFYEAR >=", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearLessThan(String value) {
            addCriterion("PK_ACCHALFYEAR <", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCHALFYEAR <=", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearLike(String value) {
            addCriterion("PK_ACCHALFYEAR like", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearNotLike(String value) {
            addCriterion("PK_ACCHALFYEAR not like", value, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearIn(List<String> values) {
            addCriterion("PK_ACCHALFYEAR in", values, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearNotIn(List<String> values) {
            addCriterion("PK_ACCHALFYEAR not in", values, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearBetween(String value1, String value2) {
            addCriterion("PK_ACCHALFYEAR between", value1, value2, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAcchalfyearNotBetween(String value1, String value2) {
            addCriterion("PK_ACCHALFYEAR not between", value1, value2, "pkAcchalfyear");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodIsNull() {
            addCriterion("PK_ACCPERIOD is null");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodIsNotNull() {
            addCriterion("PK_ACCPERIOD is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodEqualTo(String value) {
            addCriterion("PK_ACCPERIOD =", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodNotEqualTo(String value) {
            addCriterion("PK_ACCPERIOD <>", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodGreaterThan(String value) {
            addCriterion("PK_ACCPERIOD >", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCPERIOD >=", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodLessThan(String value) {
            addCriterion("PK_ACCPERIOD <", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCPERIOD <=", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodLike(String value) {
            addCriterion("PK_ACCPERIOD like", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodNotLike(String value) {
            addCriterion("PK_ACCPERIOD not like", value, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodIn(List<String> values) {
            addCriterion("PK_ACCPERIOD in", values, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodNotIn(List<String> values) {
            addCriterion("PK_ACCPERIOD not in", values, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodBetween(String value1, String value2) {
            addCriterion("PK_ACCPERIOD between", value1, value2, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andPkAccperiodNotBetween(String value1, String value2) {
            addCriterion("PK_ACCPERIOD not between", value1, value2, "pkAccperiod");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearIsNull() {
            addCriterion("ACCHALFYEAR is null");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearIsNotNull() {
            addCriterion("ACCHALFYEAR is not null");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearEqualTo(String value) {
            addCriterion("ACCHALFYEAR =", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearNotEqualTo(String value) {
            addCriterion("ACCHALFYEAR <>", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearGreaterThan(String value) {
            addCriterion("ACCHALFYEAR >", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearGreaterThanOrEqualTo(String value) {
            addCriterion("ACCHALFYEAR >=", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearLessThan(String value) {
            addCriterion("ACCHALFYEAR <", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearLessThanOrEqualTo(String value) {
            addCriterion("ACCHALFYEAR <=", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearLike(String value) {
            addCriterion("ACCHALFYEAR like", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearNotLike(String value) {
            addCriterion("ACCHALFYEAR not like", value, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearIn(List<String> values) {
            addCriterion("ACCHALFYEAR in", values, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearNotIn(List<String> values) {
            addCriterion("ACCHALFYEAR not in", values, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearBetween(String value1, String value2) {
            addCriterion("ACCHALFYEAR between", value1, value2, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andAcchalfyearNotBetween(String value1, String value2) {
            addCriterion("ACCHALFYEAR not between", value1, value2, "acchalfyear");
            return (Criteria) this;
        }

        public Criteria andBeginmonthIsNull() {
            addCriterion("BEGINMONTH is null");
            return (Criteria) this;
        }

        public Criteria andBeginmonthIsNotNull() {
            addCriterion("BEGINMONTH is not null");
            return (Criteria) this;
        }

        public Criteria andBeginmonthEqualTo(String value) {
            addCriterion("BEGINMONTH =", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthNotEqualTo(String value) {
            addCriterion("BEGINMONTH <>", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthGreaterThan(String value) {
            addCriterion("BEGINMONTH >", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthGreaterThanOrEqualTo(String value) {
            addCriterion("BEGINMONTH >=", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthLessThan(String value) {
            addCriterion("BEGINMONTH <", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthLessThanOrEqualTo(String value) {
            addCriterion("BEGINMONTH <=", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthLike(String value) {
            addCriterion("BEGINMONTH like", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthNotLike(String value) {
            addCriterion("BEGINMONTH not like", value, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthIn(List<String> values) {
            addCriterion("BEGINMONTH in", values, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthNotIn(List<String> values) {
            addCriterion("BEGINMONTH not in", values, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthBetween(String value1, String value2) {
            addCriterion("BEGINMONTH between", value1, value2, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andBeginmonthNotBetween(String value1, String value2) {
            addCriterion("BEGINMONTH not between", value1, value2, "beginmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthIsNull() {
            addCriterion("ENDMONTH is null");
            return (Criteria) this;
        }

        public Criteria andEndmonthIsNotNull() {
            addCriterion("ENDMONTH is not null");
            return (Criteria) this;
        }

        public Criteria andEndmonthEqualTo(String value) {
            addCriterion("ENDMONTH =", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthNotEqualTo(String value) {
            addCriterion("ENDMONTH <>", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthGreaterThan(String value) {
            addCriterion("ENDMONTH >", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthGreaterThanOrEqualTo(String value) {
            addCriterion("ENDMONTH >=", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthLessThan(String value) {
            addCriterion("ENDMONTH <", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthLessThanOrEqualTo(String value) {
            addCriterion("ENDMONTH <=", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthLike(String value) {
            addCriterion("ENDMONTH like", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthNotLike(String value) {
            addCriterion("ENDMONTH not like", value, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthIn(List<String> values) {
            addCriterion("ENDMONTH in", values, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthNotIn(List<String> values) {
            addCriterion("ENDMONTH not in", values, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthBetween(String value1, String value2) {
            addCriterion("ENDMONTH between", value1, value2, "endmonth");
            return (Criteria) this;
        }

        public Criteria andEndmonthNotBetween(String value1, String value2) {
            addCriterion("ENDMONTH not between", value1, value2, "endmonth");
            return (Criteria) this;
        }

        public Criteria andYearquarterIsNull() {
            addCriterion("YEARQUARTER is null");
            return (Criteria) this;
        }

        public Criteria andYearquarterIsNotNull() {
            addCriterion("YEARQUARTER is not null");
            return (Criteria) this;
        }

        public Criteria andYearquarterEqualTo(String value) {
            addCriterion("YEARQUARTER =", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterNotEqualTo(String value) {
            addCriterion("YEARQUARTER <>", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterGreaterThan(String value) {
            addCriterion("YEARQUARTER >", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterGreaterThanOrEqualTo(String value) {
            addCriterion("YEARQUARTER >=", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterLessThan(String value) {
            addCriterion("YEARQUARTER <", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterLessThanOrEqualTo(String value) {
            addCriterion("YEARQUARTER <=", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterLike(String value) {
            addCriterion("YEARQUARTER like", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterNotLike(String value) {
            addCriterion("YEARQUARTER not like", value, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterIn(List<String> values) {
            addCriterion("YEARQUARTER in", values, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterNotIn(List<String> values) {
            addCriterion("YEARQUARTER not in", values, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterBetween(String value1, String value2) {
            addCriterion("YEARQUARTER between", value1, value2, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andYearquarterNotBetween(String value1, String value2) {
            addCriterion("YEARQUARTER not between", value1, value2, "yearquarter");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}